"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepCopy = void 0;
const deepCopy = (source) => {
    let clone;
    let i;
    const hasOwnProp = Object.prototype.hasOwnProperty.bind(source);
    if (typeof source !== 'object' || source === null) {
        return source;
    }
    if (source instanceof Date) {
        return new Date(source.getTime());
    }
    if (Array.isArray(source)) {
        clone = [];
        const len = source.length;
        for (i = 0; i < len; i++) {
            clone[i] = (0, exports.deepCopy)(source[i]);
        }
        return clone;
    }
    clone = {};
    for (i in source) {
        if (hasOwnProp(i)) {
            clone[i] = (0, exports.deepCopy)(source[i]);
        }
    }
    return clone;
};
exports.deepCopy = deepCopy;
//# sourceMappingURL=utils.js.map